<template>
    <el-button v-if="hasDownloadPermission" class="download-csv" @click="downloadList" type="primary" icon="el-icon-download" >
        Download CSV
    </el-button>
</template>

<script>
import {
    DOWNLOAD_USER_CSV, DOWNLOAD_INVESTOR_CSV, DOWNLOAD_STARTUP_CSV, DOWNLOAD_SUBSCRIBER_CSV,
} from '@/constants/permissions';
import { downloadFile } from '@/utils';

export default {
    props: {
        /** filter parameters for the listing */
        filter: {
            type: Object,
            required: false,
        },
        /** listing type: users/investors/startups/subscibers */
        listType: {
            type: String,
            required: false,
            default: 'users',
        },
    },
    computed: {
        apiRoute() {
            let routeName;
            switch (this.listType) {
            case 'investors':
                routeName = DOWNLOAD_INVESTOR_CSV;
                break;
            case 'startups':
                routeName = DOWNLOAD_STARTUP_CSV;
                break;
            case 'subscribers':
                routeName = DOWNLOAD_SUBSCRIBER_CSV;
                break;
            default:
                routeName = DOWNLOAD_USER_CSV;
            }
            return routeName;
        },
        hasDownloadPermission() {
            return this.$store.getters.can(this.apiRoute);
        },
    },
    methods: {
        /**
         * Handler for the button: send request for getting generated csv file
         */
        downloadList() {
            const reqPromise = this.$store.dispatch('downloadListing', { filter: this.filter, routeName: this.apiRoute }).then((response) => {
                const blobParams = [[response.data], { type: response.headers['content-type'] }];
                const fileName = `${this.listType}.csv`;
                downloadFile(...blobParams, fileName);
            });
            this.initLoading(reqPromise);
        },
    },
};
</script>

<style lang="stylus" scoped>
.el-button + .download-csv
    margin-left: auto

</style>
